[LeetCode]236.Lowest Common Ancestor of a Binary Tree

2024-02-19 00:32

本文主要是介绍[LeetCode]236.Lowest Common Ancestor of a Binary Tree,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目

Given a binary tree, find the lowest common ancestor (LCA) of two given nodes in the tree.According to the definition of LCA on 
Wikipedia:  “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v  and w as descendants  
(where we allow a node to be a descendant of itself).”3/     \5       1
/   \    /  \
6   2   0    8/  \7    4Another example is LCA of nodes 5 and 4 is 5,  
since a node can be a descendant of itself according to the LCA definition.

代码

/*---------------------------------------
*   日期:2015-07-13
*   作者:SJF0115
*   题目: 236.Lowest Common Ancestor of a Binary Tree
*   网址:https://leetcode.com/problems/lowest-common-ancestor-of-a-binary-tree/
*   结果:AC
*   来源:LeetCode
*   博客:
-----------------------------------------*/
#include <iostream>
#include <vector>
using namespace std;struct TreeNode{int val;TreeNode *left;TreeNode *right;TreeNode(int x):val(x),left(NULL),right(NULL){}
};class Solution {
public:TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {if(root == nullptr || p == nullptr || q == nullptr){return nullptr;}//ifvector<TreeNode*> path1;bool isFind = Path(root,p,path1);// 没有P节点if(!isFind){return nullptr;}//ifvector<TreeNode*> path2;isFind = Path(root,q,path2);if(!isFind){return nullptr;}//ifint size1 = path1.size();int size2 = path2.size();// 求最近祖先TreeNode* node = nullptr;for(int i = 0,j = 0;i <= size1 && j <= size2;++i,++j){if((i == size1 || j == size2) || path1[i] != path2[j]){node = path1[i-1];break;}//if}//forreturn node;}
private:// 从根节点到node节点的路径bool Path (TreeNode* root,TreeNode* node,vector<TreeNode*> &path) {path.push_back(root);if(root == node) {return true;}//ifbool isExits = false;// 左子树if(root->left) {isExits = Path(root->left,node,path);}//if// 右子树if(!isExits && root->right) {isExits = Path(root->right,node,path);}//ifif(!isExits) {path.pop_back();}//ifreturn isExits;}
};int main(){Solution s;TreeNode* root = new TreeNode(3);TreeNode* node1 = new TreeNode(0);TreeNode* node2 = new TreeNode(1);TreeNode* node3 = new TreeNode(2);TreeNode* node4 = new TreeNode(4);TreeNode* node5 = new TreeNode(5);TreeNode* node6 = new TreeNode(6);TreeNode* node7 = new TreeNode(7);TreeNode* node8 = new TreeNode(8);root->left = node5;root->right = node2;node5->left = node6;node5->right = node3;node3->left = node7;node3->right = node4;node2->left = node1;node2->right = node8;TreeNode* node = s.lowestCommonAncestor(root,node7,node1);if(node != nullptr){cout<<node->val<<endl;}//ifelse{cout<<"nullptr"<<endl;}//elsereturn 0;
}

运行时间

这里写图片描述

这篇关于[LeetCode]236.Lowest Common Ancestor of a Binary Tree的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/722945

相关文章

哈希leetcode-1

目录 1前言 2.例题  2.1两数之和 2.2判断是否互为字符重排 2.3存在重复元素1 2.4存在重复元素2 2.5字母异位词分组 1前言 哈希表主要是适合于快速查找某个元素(O(1)) 当我们要频繁的查找某个元素,第一哈希表O(1),第二,二分O(log n) 一般可以分为语言自带的容器哈希和用数组模拟的简易哈希。 最简单的比如数组模拟字符存储,只要开26个c

uva 575 Skew Binary(位运算)

求第一个以(2^(k+1)-1)为进制的数。 数据不大,可以直接搞。 代码: #include <stdio.h>#include <string.h>const int maxn = 100 + 5;int main(){char num[maxn];while (scanf("%s", num) == 1){if (num[0] == '0')break;int len =

leetcode-24Swap Nodes in Pairs

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode swapPairs(L

leetcode-23Merge k Sorted Lists

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode mergeKLists

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟)

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟) 题目描述 给定一个链表,链表中的每个节点代表一个整数。链表中的整数由 0 分隔开,表示不同的区间。链表的开始和结束节点的值都为 0。任务是将每两个相邻的 0 之间的所有节点合并成一个节点,新节点的值为原区间内所有节点值的和。合并后,需要移除所有的 0,并返回修改后的链表头节点。 思路分析 初始化:创建一个虚拟头节点

C语言 | Leetcode C语言题解之第393题UTF-8编码验证

题目: 题解: static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num & MASK1) == 0) {return

【JavaScript】LeetCode:16-20

文章目录 16 无重复字符的最长字串17 找到字符串中所有字母异位词18 和为K的子数组19 滑动窗口最大值20 最小覆盖字串 16 无重复字符的最长字串 滑动窗口 + 哈希表这里用哈希集合Set()实现。左指针i,右指针j,从头遍历数组,若j指针指向的元素不在set中,则加入该元素,否则更新结果res,删除集合中i指针指向的元素,进入下一轮循环。 /*** @param

树(Tree)——《啊哈!算法》

树 什么是树?树是一种特殊的图,不包含回路的连通无向树。 正因为树有着“不包含回路”这个特点,所以树就被赋予了很多特性。 一棵树中的任意两个结点有且仅有唯一的一条路径连通。一棵树如果有n个结点,那么它一定恰好有n-1条边。在一棵树中加一条边将会构成一个回路。 一棵树有且只有一个根结点。 没有父结点的结点称为根结点(祖先)。没有子结点的结点称为叶结点。如果一个结点既不是根结点也不是叶

LeetCode:64. 最大正方形 动态规划 时间复杂度O(nm)

64. 最大正方形 题目链接 题目描述 给定一个由 0 和 1 组成的二维矩阵,找出只包含 1 的最大正方形,并返回其面积。 示例1: 输入: 1 0 1 0 01 0 1 1 11 1 1 1 11 0 0 1 0输出: 4 示例2: 输入: 0 1 1 0 01 1 1 1 11 1 1 1 11 1 1 1 1输出: 9 解题思路 这道题的思路是使用动态规划